#property copyright "MaxZ"
#property link      "zagizop@yandex.ru"

extern   string   Paramerts01          = " MM:";
extern   double   Risk                 = 2.6;   // 0 -  ; > 0 -  .
extern   double   Lots                 = 0.1;   //   ( Risk = 0).
extern   double   LotsExp              = 1.0;   //        
double   LotsB, LotsS, LotsBs, LotsSs;
extern   string   Paramerts02          = ":";
extern   int      Slippage             = 2;     // .
extern   string   Paramerts03          = " :";
extern   bool     ModeHold             = false; //       BUY  SELL .
extern   string   Paramerts04          = " :";
extern   bool     loseAtCrossedWithMA = false; //     MA?
extern   int      FromWhatOrderClosed  = 2;     //         MA?
extern   bool     HoldSignal           = false; //      ? 
extern   bool     CloseOnlyForBands    = true;  //     ?
extern   bool     CloseOnlySeries      = false; //    ?     ?
extern   string   Paramerts05          = "   :";
extern   int      MinTP                = 10;    //   TakeProfit'.
extern   int      MinSL                = 0;     //  > 0,     StopLoss'.
extern   int      MinPipStep           = 10;    //     .
extern   bool     ModeLadder           = false; //  .  BUY-  ,  SELL-  .
extern   string   Paramerts06          = "  :";
extern   int      ModeBands            = 0;     // 0 - ATR Bands; 1 - Bollinger Bands.
extern   int      Per                  = 45;    //   .
extern   double   Dev                  = 3.0;   // .
extern   int      MinStep              = 1;     //   ( ),     .
int      DirMA = 0;
double   Step, MA;
extern   string   Paramerts07          = " :";
extern   bool     Overlapping          = false; //      .
extern   int      LeadingOrder         = 2;     //     
int      LPos = 0, CPos = 0;
double   LProfit = 0, CProfit = 0;
extern   string   Paramerts08          = " SafeMode:";
extern   double   ExtremeDrawdown      = 100.0; //   > ExtremeDrawdown,   SafeMode.
bool     SafeMode;
double   Drawdown, MaxDrawdown, MinDrawdown, PivotBalance, AccumEquityB, AccumEquityS;
extern   string   Paramerts09          = " :";
extern   bool     Debug                = false; //     ""?
extern   bool     Info                 = false; //    ?
extern   bool     DrawArrows           = false; //  -?
extern   color    ColorArrowUp         = Blue;  //   .
extern   color    ColorArrowDn         = Red;   //   .

int      MagicB = 0, MagicS = 0, LastMagicB, LastMagicS;

int      Bs, Ss;

double   Profit, MaxProfit,
         BalanceB, ProfitB, EquityB,
         MaxEquityB, MinEquityB,
         LastProfitB, LastRealProfitB,
         BalanceS, ProfitS, EquityS,
         MaxEquityS, MinEquityS,
         LastProfitS, LastRealProfitS;

string   Symb;

bool     SendB, SendS, ClsB, ClsS;

int      i,
         Pos, Ticket, Error;

int init()
{
   Symb = Symbol();
   
   int Pos;
   if (MagicB <= 0)
   {
      MagicB = 0;
      for (Pos = OrdersHistoryTotal()-1; Pos >= 0; Pos--)
         if (OrderSelect(Pos, SELECT_BY_POS))
            if (OrderType() == OP_BUY )
            {
               MagicB = OrderMagicNumber();
               LotsB = OrderLots();
               break;
            }
      if (MagicB == 0)
         MagicB = NewMagic();
   }
   if (MagicS <= 0)
   {
      MagicS = 0;
      for (Pos = OrdersHistoryTotal()-1; Pos >= 0; Pos--)
         if (OrderSelect(Pos, SELECT_BY_POS))
            if (OrderType() == OP_SELL)
            {
               MagicS = OrderMagicNumber();
               LotsS = OrderLots();
               break;
            }
      if (MagicS == 0)
         MagicS = NewMagic();
   }
   
   if (LotsB == 0.0 || LotsS == 0.0)
   {
      Lots = GetLots(Risk);
      if (LotsB != 0.0)
      {
         if (LotsB > Lots)
            LotsS = LotsB;
         else
            LotsS = Lots;
      }
      else
      if (LotsS != 0.0)
      {
         if (LotsS > Lots)
            LotsB = LotsS;
         else
            LotsB = Lots;
      }
      else
      {
         LotsB = Lots;
         LotsS = Lots;
      }
   }
}

int start()
{
   double   Drawdown = (AccountEquity()-AccountBalance())*100.0/AccountBalance();
   if (Drawdown < MaxDrawdown)
      MaxDrawdown = Drawdown;
   if (Drawdown > MinDrawdown)
      MinDrawdown = Drawdown;
   if (!SafeMode)
      if (Drawdown < -ExtremeDrawdown)
         SafeMode = true;
   
   CalculateOrdersValues();
   
   if (ModeBands == 0)
      Step = MathMax(MinStep*Point, Dev*iATR(NULL, 0, Per, 0));
   else
      Step = MathMax(MinStep*Point, Dev*iStdDev(NULL, 0, Per, 0, MODE_SMA, PRICE_CLOSE, 0));
   MA = iMA(NULL, 0, Per, 0, MODE_SMA, PRICE_CLOSE, 0);
   
   if (Bid > MA+(DirMA+1)*Step-0.5*Point)
   {
      DirMA++;
      if (DrawArrows)
         if (DirMA > 0)
            SetArrow(StringConcatenate("Dir=+", DirMA, " ", TimeToStr(TimeCurrent())), 0, Bid, 241, 3, ColorArrowUp);
         else
            SetArrow(StringConcatenate("Dir=",  DirMA, " ", TimeToStr(TimeCurrent())), 0, Bid, 241, 3, ColorArrowUp);
      
      if (DirMA == +1)
      {
         ClsB = true;
         if (HoldSignal || Ss == 0 || (ModeLadder && Bid-FindLastSellPrice() > (MinPipStep-0.5)*Point) || (!ModeLadder && !FindMatchSellPrice()))
            SendS = true;
      }
      else
      if (DirMA == 0)
      {
         if (loseAtCrossedWithMA)
            if (Bs >= FromWhatOrderClosed)
               ClsB = true;
         ClsS = false;
         SendB = false;
      }
   }
   else
   if (Bid < MA+(DirMA-1)*Step+0.5*Point)
   {
      DirMA--;
      if (DrawArrows)
         if (DirMA > 0)
            SetArrow(StringConcatenate("Dir=+", DirMA, " ", TimeToStr(TimeCurrent())), 0, Bid, 242, 3, ColorArrowDn);
         else
            SetArrow(StringConcatenate("Dir=",  DirMA, " ", TimeToStr(TimeCurrent())), 0, Bid, 242, 3, ColorArrowDn);
      
      if (DirMA == -1)
      {
         ClsS = true;
         if (HoldSignal || Bs == 0 || (ModeLadder && FindLastBuyPrice()-Ask > (MinPipStep-0.5)*Point) || (!ModeLadder && !FindMatchBuyPrice()))
            SendB = true;
      }
      else
      if (DirMA == 0)
      {
         if (loseAtCrossedWithMA)
            if (Ss >= FromWhatOrderClosed)
               ClsS = true;
         ClsB = false;
         SendS = false;
      }
   }
   
   if (SafeMode)
      if (ClsB || ClsS)
         if (AccumEquityB+AccumEquityS+EquityB+EquityS > 0.0)
         {
            CloseB(MagicB);
            CloseS(MagicS);
            
            ClsB = false;
            ClsS = false;
         }
   
   if (Overlapping)
   {
      if (ClsB)
         if (ModeHold || EquityB < 0.0)
            if (ModeHold || Bs >= LeadingOrder)
            {
               LProfit = 0.0;
               for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
                  if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES)) 
                     if (OrderSymbol() == Symbol())
                        if (OrderType() == OP_BUY )
                           if (OrderMagicNumber() == MagicB)
                           {
                              Profit = OrderProfit();
                              if (Profit > LProfit)
                              {
                                 LProfit = Profit;
                                 LPos    = OrderTicket();
                              }
                           }
               if (LProfit > 0.0)
               {
                  CProfit = 0.0;
                  
                  if (!ModeHold || LotsBs > LotsSs*0.5)
                  {
                     for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
                        if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES)) 
                           if (OrderSymbol() == Symbol())
                           {
                              if (OrderType() == OP_BUY )
                                 if (OrderMagicNumber() == MagicB)
                                 {
                                    Profit = OrderProfit();
                                    if (Profit < CProfit)
                                       if (LProfit > -Profit)
                                       {
                                          CProfit = Profit;
                                          CPos    = OrderTicket();
                                       }
                                 }
                           }
                  }
                  else
                     for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
                        if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES)) 
                           if (OrderSymbol() == Symbol())
                              if (OrderType() == OP_SELL)
                                 if (OrderMagicNumber() == MagicS)
                                 {
                                    Profit = OrderProfit();
                                    if (Profit < CProfit)
                                       if (LProfit > -Profit)
                                       {
                                          CProfit = Profit;
                                          CPos    = OrderTicket();
                                       }
                                 }
                  
                  if (CProfit < 0.0)
                  {
                     OrderSelect(CPos, SELECT_BY_TICKET, MODE_TRADES);
                     CloseSelectOrder();
                     OrderSelect(LPos, SELECT_BY_TICKET, MODE_TRADES);
                     CloseSelectOrder();
                  }
               }
            }
      if (ClsS)
         if (ModeHold || EquityS < 0.0)
            if (ModeHold || Ss >= LeadingOrder)
            {
               LProfit = 0.0;
               
               for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
                  if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES)) 
                     if (OrderSymbol() == Symbol())
                        if (OrderType() == OP_SELL)
                           if (OrderMagicNumber() == MagicS)
                           {
                              Profit = OrderProfit();
                              if (Profit > LProfit)
                              {
                                 LProfit = Profit;
                                 LPos    = OrderTicket();
                              }
                           }
               if (LProfit > 0.0)
               {
                  CProfit = 0.0;
                  
                  if (!ModeHold || LotsSs > LotsBs*0.5)
                  {
                     for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
                        if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES)) 
                           if (OrderSymbol() == Symbol())
                           {
                              if (OrderType() == OP_SELL)
                                 if (OrderMagicNumber() == MagicS)
                                 {
                                    Profit = OrderProfit();
                                    if (Profit < CProfit)
                                       if (LProfit > -Profit)
                                       {
                                          CProfit = Profit;
                                          CPos    = OrderTicket();
                                       }
                                 }
                           }
                  }
                  else
                     for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
                        if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES)) 
                           if (OrderSymbol() == Symbol())
                              if (OrderType() == OP_BUY )
                                 if (OrderMagicNumber() == MagicB)
                                 {
                                    Profit = OrderProfit();
                                    if (Profit < CProfit)
                                       if (LProfit > -Profit)
                                       {
                                          CProfit = Profit;
                                          CPos    = OrderTicket();
                                       }
                                 }
                  
                  if (CProfit < 0.0)
                  {
                     OrderSelect(CPos, SELECT_BY_TICKET, MODE_TRADES);
                     CloseSelectOrder();
                     OrderSelect(LPos, SELECT_BY_TICKET, MODE_TRADES);
                     CloseSelectOrder();
                  }
               }
            }
   }
   
   if (!ModeHold)
   {
      LotsBs = 0.0;
      LotsSs = 0.0;
      for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
         if (OrderSelect(Pos, SELECT_BY_POS))
            if (OrderSymbol() == Symb)
            {
               if (OrderMagicNumber() == MagicB)
                  if (OrderType() == OP_BUY )
                     LotsBs += OrderLots();
               if (OrderMagicNumber() == MagicS)
                  if (OrderType() == OP_SELL)
                     LotsSs += OrderLots();
            }
   }
   else
   {
      ClsB = false;
      ClsS = false;
   }
   
   if (ClsB)
   {
      i = 1;
      if (MinSL == 0)
         if (EquityB > 0.0)
            if (Bs > 1 || Bid-FindLastBuyPrice()-0.5*Point > MinTP*Point)
               if (!CloseOnlyForBands || Bid > MA+Step-0.5*Point || (loseAtCrossedWithMA && DirMA == 0))
               {
                  CloseB(MagicB);
                  i = 0;
               }
      if (i > 0)
         if (!CloseOnlySeries)
            if (!CloseOnlyForBands || Bid > MA+Step-0.5*Point || (loseAtCrossedWithMA && DirMA == 0))
               for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
                  if (OrderSelect(Pos, SELECT_BY_POS))
                     if (OrderType() == OP_BUY )
                        if (OrderMagicNumber() == MagicB)
                           if (Bid-OrderOpenPrice()-0.5*Point > MinTP*Point || (MinSL > 0 && Bid-OrderOpenPrice()+0.5*Point < -MinSL*Point))
                           {
                              Ticket = OrderTicket();
                              RefreshRates();
                              if (OrderClose(Ticket, OrderLots(), Bid, Slippage))
                              {
                                 if (Debug)
                                    Print("Order BUY close, ticket #", Ticket, ".");
                              }
                              else
                              { 
                                 if (Debug)
                                    Print("Order BUY not close, ticket #", Ticket, ", error #", GetLastError(), "!");
                                 return;
                              }
                           }
      if (!HoldSignal)
         ClsB = false;
   }
   if (ClsS)
   {
      i = 1;
      if (MinSL == 0)
         if (EquityS > 0.0)
            if (Ss > 1 || FindLastSellPrice()-Ask-0.5*Point > MinTP*Point)
               if (!CloseOnlyForBands || Bid < MA-Step+0.5*Point || (loseAtCrossedWithMA && DirMA == 0))
               {
                  CloseS(MagicS);
                  i = 0;
               }
      if (i > 0)
         if (!CloseOnlySeries)
            if (!CloseOnlyForBands || Bid < MA-Step+0.5*Point || (loseAtCrossedWithMA && DirMA == 0))
               for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
                  if (OrderSelect(Pos, SELECT_BY_POS))
                     if (OrderType() == OP_SELL)
                        if (OrderMagicNumber() == MagicS)
                           if (OrderOpenPrice()-Ask-0.5*Point > MinTP*Point || (MinSL > 0 && OrderOpenPrice()-Ask+0.5*Point < -MinSL*Point))
                           {
                              Ticket = OrderTicket();
                              RefreshRates();
                              if (OrderClose(Ticket, OrderLots(), Ask, Slippage))
                              {
                                 if (Debug)
                                    Print("Order SELL close, ticket #", Ticket, ".");
                              }
                              else
                              {
                                 if (Debug)
                                    Print("Order SELL not close, ticket #", Ticket, ", error #", GetLastError(), "!");
                                 return;
                              }
                           }
      if (!HoldSignal)
         ClsS = false;
   }
   
   if (Bs > 0)
   {
      Bs = 0;
      for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
         if (OrderSelect(Pos, SELECT_BY_POS))
            if (OrderSymbol() == Symb)
               if (OrderMagicNumber() == MagicB)
                  if (OrderType() == OP_BUY )
                     Bs++;
      if (Bs == 0)
      {
         LastMagicB = MagicB;
         LastProfitB = EquityB;
         LastRealProfitB = DefineProfit(MagicB);
         MagicB = 0;
         MagicB = NewMagic();
         
         MaxEquityB = 0.0;
         MinEquityB = 0.0;
         
         if (Ss > 0)
            AccumEquityB += LastRealProfitB;
      }
   }
   if (Ss > 0)
   {
      Ss = 0;
      for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
         if (OrderSelect(Pos, SELECT_BY_POS))
            if (OrderSymbol() == Symb)
               if (OrderMagicNumber() == MagicS)
                  if (OrderType() == OP_SELL)
                     Ss++;
      if (Ss == 0)
      {
         LastMagicS = MagicS;
         LastProfitS = EquityS;
         LastRealProfitS = DefineProfit(MagicS);
         MagicS = 0;
         MagicS = NewMagic();
         
         MaxEquityS = 0.0;
         MinEquityS = 0.0;
         
         if (Bs > 0)
            AccumEquityS += LastRealProfitS;
      }
   }
   
   if (Bs == 0 && Ss == 0)
   {
      PivotBalance = AccountBalance();
      AccumEquityB = 0.0;
      AccumEquityS = 0.0;
      SafeMode = false;
   }
   
   if (SendB || SendS)
   {
      if (Bs == 0 && Ss == 0)
         Lots = GetLots(Risk);
      
      if (SendB)
         if (Bid < MA-Step+0.5*Point)
            if (Bs == 0 || (ModeLadder && FindLastBuyPrice()-Ask > (MinPipStep-0.5)*Point) || (!ModeLadder && !FindMatchBuyPrice()))
            {
               if (LotsExp == 1.0)
               {
                  Lots = GetLots(Risk);
                  if (Lots > LotsB)
                     LotsB = Lots;
               }
               else
               {
                  LotsB = Lots*MathPow(LotsExp, Bs);
                  if (LotsB > MarketInfo(Symb, MODE_MAXLOT))
                     LotsB = MarketInfo(Symb, MODE_MAXLOT);
               }
               
               RefreshRates();
               Ticket = OrderSend(Symbol(), OP_BUY,  MathFloor(LotsB*100)*MarketInfo(Symb, MODE_LOTSTEP), Ask, Slippage, 0, 0, NULL, MagicB);
               if (Ticket > 0)
               {
                  SendB = false;
                  if (Debug)
                     Print("Order BUY open, ticket #", Ticket, ".");
               }
               else
               {
                  Error = GetLastError();
                  if (Error == 134 || Error == 148)
                     SendB = false;
                  if (Error == 131)
                  {
                     SendB = false;
                     Print("  = ", LotsB);
                  }
                  if (Debug)
                     Print("Order BUY not open, ticket #", Ticket, ", error #", Error, "!");
               }
      }
      if (SendS)
         if (Bid > MA+Step-0.5*Point)
            if (Ss == 0 || (ModeLadder && Bid-FindLastSellPrice() > (MinPipStep-0.5)*Point) || (!ModeLadder && !FindMatchSellPrice()))
            {
               if (LotsExp == 1.0)
               {
                  Lots = GetLots(Risk);
                  if (Lots > LotsS)
                     LotsS = Lots;
               }
               else
               {
                  LotsS = Lots*MathPow(LotsExp, Ss);
                  if (LotsS > MarketInfo(Symb, MODE_MAXLOT))
                     LotsS = MarketInfo(Symb, MODE_MAXLOT);
               }
               
               RefreshRates();
               Ticket = OrderSend(Symbol(), OP_SELL, MathFloor(LotsS*100)*MarketInfo(Symb, MODE_LOTSTEP), Bid, Slippage, 0, 0, NULL, MagicS);
               if (Ticket > 0)
               {
                  SendS = false;
                  if (Debug)
                     Print("Order SELL open, ticket #", Ticket, ".");
               }
               else
               {
                  Error = GetLastError();
                  if (Error == 134 || Error == 148)
                     SendS = false;
                  if (Error == 131 || Error == 4051)
                  {
                     SendS = false;
                     Print("  = ", LotsS);
                  }
                  if (Debug)
                     Print("Order SELL not open, ticket #", Ticket, ", error #", Error, "!");
               }
            }
   }
   
   if (Info)
   {
      string Comments = StringConcatenate(
         "MA= ", MA, "  Up=", MA+Step, "  Dn=", MA-Step,
         "\nStep = ", Step, "  DirMA=", DirMA,
         "\n",
         "\nSendB=", SendB, "  SendS=", SendS, "  ClsB=", ClsB, "  ClsS=", ClsS,
         "\nLotsBs=", LotsBs, "  LotsSs=", LotsSs, "  Orders=", Bs+Ss);
     Comments = StringConcatenate(Comments,
         "\n",
         "\nBs=", Bs, "  Magic=", MagicB,
         "\nBalance=", BalanceB, "  Profit=", ProfitB,
         "\nEquity=", EquityB, "  Max=", MaxEquityB, "  Min=", MinEquityB,
         "\nLastMagic=", LastMagicB, "  LastProfit=", LastProfitB, "  LastRealProfit=", LastRealProfitB,
         "\n",
         "\nSs=", Ss, "  Magic=", MagicS,
         "\nBalance=", BalanceS, "  Profit=", ProfitS,
         "\nEquity=", EquityS, "  Max=", MaxEquityS, "  Min=", MinEquityS,
         "\nLastMagic=", LastMagicS, "  LastProfit=", LastProfitS, "  LastRealProfit=", LastRealProfitS);
      Comments = StringConcatenate(Comments,
         "\n",
         "\nDrawdown=", DoubleToStr(Drawdown, 2), "%  ", "Max=", DoubleToStr(MaxDrawdown, 2), "%  ", "Max=", DoubleToStr(MinDrawdown, 2), "%",
         "\nPivot=", PivotBalance, "  Equity=", AccumEquityB+AccumEquityS+EquityB+EquityS, "  AccumB=", AccumEquityB, "  AccumS=", AccumEquityS);
      Comment(Comments);
   }
}

int NewMagic()
{
   int Magic = -1;
   while (Magic < 0)
   {
      Magic = -Magic;
      for (Pos = OrdersHistoryTotal()-1; Pos >= 0; Pos--)
         if (OrderSelect(Pos, SELECT_BY_POS, MODE_HISTORY))
            if (OrderMagicNumber() != Magic)
               continue;
            else
            {
               Magic = -Magic-1;
               break;
            }
      if (Magic > 0)
         for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
            if (OrderSelect(Pos, SELECT_BY_POS))
               if (OrderMagicNumber() != Magic)
                  continue;
               else
               {
                  Magic = -Magic-1;
                  break;
               }
      if (Magic == MagicB || Magic == MagicS)
         Magic = -Magic-1;
   }
   return(Magic);
}

void CalculateOrdersValues()
{
   BalanceB = 0.0;
   BalanceS = 0.0;
   for (Pos = OrdersHistoryTotal()-1; Pos >= 0; Pos--)
      if (OrderSelect(Pos, SELECT_BY_POS, MODE_HISTORY))
         if (OrderSymbol() == Symb)
         {
            if (OrderType() == OP_BUY )
            {
               if (OrderMagicNumber() == MagicB)
                  BalanceB += OrderProfit();
            }
            else
            if (OrderType() == OP_SELL)
            {
               if (OrderMagicNumber() == MagicS)
                  BalanceS += OrderProfit();
            }
         }
   Bs = 0;
   Ss = 0;
   LotsBs = 0.0;
   LotsSs = 0.0;
   ProfitB = 0.0;
   ProfitS = 0.0;
   for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
      if (OrderSelect(Pos, SELECT_BY_POS))
         if (OrderType() == OP_BUY )
         {
            if (OrderMagicNumber() == MagicB)
            {
               Bs++;
               LotsBs += OrderLots();
               ProfitB += OrderProfit();
            }
         }
         else
         if (OrderType() == OP_SELL)
         {
            if (OrderMagicNumber() == MagicS)
            {
               Ss++;
               LotsSs += OrderLots();
               ProfitS += OrderProfit();
            }
         }
   EquityB = BalanceB+ProfitB;
   EquityS = BalanceS+ProfitS;
   
   if (EquityB > MaxEquityB)
      MaxEquityB  = EquityB;
   if (EquityB < MinEquityB)
      MinEquityB  = EquityB;
   if (EquityS > MaxEquityS)
      MaxEquityS  = EquityS;
   if (EquityS < MinEquityS)
      MinEquityS  = EquityS;
}

bool FindMatchBuyPrice () 
{
   for (int Pos = OrdersTotal()-1; Pos >= 0; Pos--)
      if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol() == Symbol())
            if (OrderMagicNumber() == MagicB) 
               if (OrderType() == OP_BUY)
                  if (MathAbs(Ask-OrderOpenPrice()) < (MinPipStep-0.5)*Point)
                     return(true);
  return (false);
}

bool FindMatchSellPrice() 
{
   for (int Pos = OrdersTotal()-1; Pos >= 0; Pos--) 
      if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol() == Symbol()) 
            if (OrderMagicNumber() == MagicS) 
               if (OrderType() == OP_SELL) 
                  if (MathAbs(OrderOpenPrice()-Bid) < (MinPipStep-0.5)*Point)
                     return(true);
  return(false);
}

double FindLastBuyPrice () 
{
   double LastPrice = 0;
   
   for (int Pos = OrdersTotal()-1; Pos >= 0; Pos--)
      if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol() == Symbol())
            if (OrderMagicNumber() == MagicB) 
               if (OrderType() == OP_BUY) 
               {
                  if (LastPrice == 0)
                  {
                     LastPrice = OrderOpenPrice();
                     continue;
                  }
                  if (OrderOpenPrice() < LastPrice)
                  {
                     LastPrice = OrderOpenPrice();
                  }
               }
  return (LastPrice);
}

double FindLastSellPrice() 
{
   double LastPrice = 0;
   
   for (int Pos = OrdersTotal()-1; Pos >= 0; Pos--) 
      if (OrderSelect(Pos, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol() == Symbol()) 
            if (OrderMagicNumber() == MagicS) 
               if (OrderType() == OP_SELL) 
               {
                  if (LastPrice == 0)
                  {
                     LastPrice = OrderOpenPrice();
                     continue;
                  }
                  if (OrderOpenPrice() > LastPrice)
                  {
                     LastPrice = OrderOpenPrice();
                  }
               }
  return(LastPrice);
}

double DefineProfit(int Magic)
{
   int      Pos;
   double   Profit = 0.0;
   for (Pos = OrdersHistoryTotal()-1; Pos >= 0; Pos--)
      if (OrderSelect(Pos, SELECT_BY_POS, MODE_HISTORY))
         if (OrderMagicNumber() == Magic)
            Profit += OrderProfit();
   return(Profit);
}

void CloseSelectOrder()
{
   if (OrderType() == OP_BUY )
   {
      if (OrderMagicNumber() == MagicB)
      {
         Ticket = OrderTicket();
         RefreshRates();
         if (OrderClose(Ticket, OrderLots(), Bid, Slippage))
         {
            if (Debug)
               Print("Order BUY close, ticket #", Ticket, ".");
         }
         else
            if (Debug)
               Print("Order BUY not close, ticket #", Ticket, ", error #", GetLastError(), "!");
      }
   }
   else
   if (OrderType() == OP_SELL)
   {
      if (OrderMagicNumber() == MagicS)
      {
         Ticket = OrderTicket();
         RefreshRates();
         if (OrderClose(Ticket, OrderLots(), Ask, Slippage))
         {
            if (Debug)
               Print("Order SELL close, ticket #", Ticket, ".");
         }
         else
            if (Debug)
               Print("Order SELL not close, ticket #", Ticket, ", error #", GetLastError(), "!");
      }
   }
}

void CloseB(int Magic)
{
   int   Total,
         Pos;
   for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
      if (OrderSelect(Pos, SELECT_BY_POS))
         if (OrderMagicNumber() == Magic && OrderSymbol() == Symb)
         {
            if (OrderType() == OP_BUY )
               Total++;
         }
   if (Debug)
      Print("B=", Total, ".");
   
   if (Total == 0)
   {
      if (Debug)
         Print("OrdersTotal=0.");
      return;
   }
   
   int   Ticket;
   while (Total > 0)
   {
      for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
         if (OrderSelect(Pos, SELECT_BY_POS))
            if (OrderMagicNumber() == Magic && OrderSymbol() == Symb)
               if (OrderType() == OP_BUY )
               {
                  Ticket = OrderTicket();
                  RefreshRates();
                  if (OrderClose(Ticket, OrderLots(), Bid, Slippage))
                  {
                     Total--;
                     if (Debug)
                     {
                        Print("Order BUY close, ticket #", Ticket, ".");
                        Print("OrdersTotal=", Total, ".");
                     }
                  }
                  else
                     if (Debug)
                        Print("Order BUY not close, error #", GetLastError(), "!");
               }
   }
}

void CloseS(int Magic)
{
   int   Total,
         Pos;
   for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
      if (OrderSelect(Pos, SELECT_BY_POS))
         if (OrderMagicNumber() == Magic && OrderSymbol() == Symb)
         {
            if (OrderType() == OP_SELL)
               Total++;
         }
   if (Debug)
      Print("B=", Total, ".");
   
   if (Total == 0)
   {
      if (Debug)
         Print("OrdersTotal=0.");
      return;
   }
   
   int   Ticket;
   while (Total > 0)
   {
      for (Pos = OrdersTotal()-1; Pos >= 0; Pos--)
         if (OrderSelect(Pos, SELECT_BY_POS))
            if (OrderMagicNumber() == Magic && OrderSymbol() == Symb)
               if (OrderType() == OP_SELL)
               {
                  Ticket = OrderTicket();
                  RefreshRates();
                  if (OrderClose(Ticket, OrderLots(), Ask, Slippage))
                  {
                     Total--;
                     if (Debug)
                     {
                        Print("Order SELL close, ticket #", Ticket, ".");
                        Print("OrdersTotal=", Total, ".");
                     }
                  }
                  else
                     if (Debug)
                        Print("Order BUY not close, error #", GetLastError(), "!");
               }
   }
}

double GetLots(double Risk)
{
   double Free    = AccountFreeMargin();
   double One_Lot = MarketInfo(Symb, MODE_MARGINREQUIRED);
   double Value;
   
   if (Risk > 0)
   {
      double Step    = MarketInfo(Symb, MODE_LOTSTEP);
      Value   = MathFloor(Free*Risk/100/One_Lot/Step)*Step;
   }
   else
      Value = Lots;
   
   double Min_Lot = MarketInfo(Symb, MODE_MINLOT);
   double Max_Lot = MarketInfo(Symb, MODE_MAXLOT);
   
   if (Value < Min_Lot)
      Value = Min_Lot;
   if (Value > Max_Lot)
      Value = Max_Lot;
   
   if (Value*One_Lot > Free)
      return(-Value);
   
   return (Value);
}

int SetArrow(string Name, int Bar, double Price, int Code, int Width, color Color)
{
   if (!ObjectCreate(Name,OBJ_ARROW,0,0,0,0,0,0,0))
   {
      Alert(GetLastError());
      return(0);
   }
   if (!ObjectSet(Name,OBJPROP_ARROWCODE,Code))
      Alert(GetLastError());
   if (!ObjectSet(Name,OBJPROP_STYLE,DRAW_ARROW))
      Alert(GetLastError());
   if (!ObjectSet(Name,OBJPROP_TIME1,Time[Bar]))
      Alert(GetLastError());
   if (!ObjectSet(Name,OBJPROP_PRICE1,Price))
      Alert(GetLastError());
   if (!ObjectSet(Name,OBJPROP_WIDTH,Width))
      Alert(GetLastError());
   if (!ObjectSet(Name,OBJPROP_COLOR,Color))
      Alert(GetLastError());

   return(1);
}